﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEditor;
using Sirenix.OdinInspector.Editor;
using KairoEngine.Inventory;

namespace KairoEngine.Inventory.Editor
{
    [CustomEditor(typeof(ItemBase))]
    public class ItemBaseEditor : OdinEditor
    {
        public override Texture2D RenderStaticPreview(string assetPath, Object[] subAssets, int width, int height)
        {
            ItemBase item = (ItemBase)target;
            Texture2D texture = new Texture2D(width, height);
            EditorUtility.CopySerialized(item.icon.texture, texture);
            return texture;
        }
    }

    [CustomEditor(typeof(ItemBaseFirearm))]
    public class ItemBaseFirearmEditor : OdinEditor
    {
        public override Texture2D RenderStaticPreview(string assetPath, Object[] subAssets, int width, int height)
        {
            ItemBase item = (ItemBase)target;
            Texture2D texture = new Texture2D(width, height);
            EditorUtility.CopySerialized(item.icon.texture, texture);
            return texture;
        }
    }

    [CustomEditor(typeof(ItemBaseAmmo))]
    public class ItemBaseAmmoEditor : OdinEditor
    {
        public override Texture2D RenderStaticPreview(string assetPath, Object[] subAssets, int width, int height)
        {
            ItemBase item = (ItemBase)target;
            Texture2D texture = new Texture2D(width, height);
            EditorUtility.CopySerialized(item.icon.texture, texture);
            return texture;
        }
    }

    [CustomEditor(typeof(ItemBaseInstantEffect))]
    public class ItemBaseInstantEffectEditor : OdinEditor
    {
        public override Texture2D RenderStaticPreview(string assetPath, Object[] subAssets, int width, int height)
        {
            ItemBase item = (ItemBase)target;
            Texture2D texture = new Texture2D(width, height);
            EditorUtility.CopySerialized(item.icon.texture, texture);
            return texture;
        }
    }

    [CustomEditor(typeof(ItemBaseHandWeapon))]
    public class ItemBaseHandWeaponEditor : OdinEditor
    {
        public override Texture2D RenderStaticPreview(string assetPath, Object[] subAssets, int width, int height)
        {
            ItemBase item = (ItemBase)target;
            Texture2D texture = new Texture2D(width, height);
            EditorUtility.CopySerialized(item.icon.texture, texture);
            return texture;
        }
    }
}