﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Sirenix.OdinInspector;

namespace KairoEngine.Inventory
{
    public enum ItemType
    {
        simple,
        firearm,
        ammo,
        instantEffect,
        handWeapon
    }

    [CreateAssetMenu(fileName = "Item", menuName = "KairoEngine/Items/Item", order = 1)]
    public class ItemBase : ScriptableObject
    {
        [Space]
        [VerticalGroup("row1/left")]
        public ItemType category;
        
        [VerticalGroup("row1/left")]
        public string title;
        
        [VerticalGroup("row1/left")]
        public int value = 0;

        [VerticalGroup("row1/left")]
        public bool stackble = false;
        
        [VerticalGroup("row1/left")]
        public GameObject prefab;

        [VerticalGroup("row1/left")]
        public Sprite icon;

        [Space]
        [HideLabel]
        [PreviewField(100, ObjectFieldAlignment.Right)]
        [HorizontalGroup("row1", 110), VerticalGroup("row1/right")]
        public Sprite image;

        [TextArea(4, 5)]
        public string description;
        
        

        
    }
}
