﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Sirenix.OdinInspector;
using KairoEngine.SFX;

namespace KairoEngine.Inventory
{
    public enum HandWeaponType
    {
        Club,
        Sword,
        Knife,
        Spear
    }

    [CreateAssetMenu(fileName = "Item", menuName = "KairoEngine/Items/Hand Weapon Item", order = 4)]
    public class ItemBaseHandWeapon : ItemBaseHoldable
    {
        [TitleGroup("Hand Weapon Properties")]
        public HandWeaponType weaponType;

        [TitleGroup("Hand Weapon Properties")]
        public int damage = 1;

        [TitleGroup("Hand Weapon Properties")]
        public float attackDistance = 1.3f;

        [TitleGroup("Weapon Properties")]
        public SFXClip attackSound;
    }
}