﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using KairoEngine.Core;
using Sirenix.OdinInspector;

namespace KairoEngine.Inventory
{
    [System.Serializable]
    public class ItemRef 
    {
        [HorizontalGroup("itemRef", 0.85f), HideLabel] public ItemBase item;
        [HorizontalGroup("itemRef", 0.15f), HideLabel] public int quantity = 1;
        [HideInInspector] public float lastUsed = 10000f;

        public ItemRef(ItemBase item, int quantity, float lastUsed = 0f)
        {
            this.item = item;
            this.quantity = quantity;
            this.lastUsed = lastUsed;
        }
    }

    [System.Serializable]
    public class ItemFirearmRef : ItemRef
    {
        public ItemBaseAmmo ammoType;
        public int ammo;

        public float accuracyModifier = 0f;

        public ItemFirearmRef(ItemBase item, int quantity, ItemBaseAmmo ammoType, int ammo, float accuracyModifier = 0f, float lastUsed = 0f) : base(item, quantity, lastUsed)
        {
            this.ammoType = ammoType;
            this.ammo = ammo;
        }
    }

}